import { renderless, api } from "@dftvue2-opentiny/vue-renderless/recycle-scroller/vue";
import { defineComponent, props, setup as _setup } from "@dftvue2-opentiny/vue-common";
import ObserveVisibility from "@dftvue2-opentiny/vue-renderless/common/deps/observe-visibility";
import "@dftvue2-opentiny/vue-theme/recycle-scroller/index.css";
function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  if (functionalTemplate) {
    options.functional = true;
  }
  if (scopeId) {
    options._scopeId = "data-v-" + scopeId;
  }
  var hook;
  if (moduleIdentifier) {
    hook = function hook2(context) {
      context = context || // cached call
      this.$vnode && this.$vnode.ssrContext || // stateful
      this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext;
      if (!context && typeof __VUE_SSR_CONTEXT__ !== "undefined") {
        context = __VUE_SSR_CONTEXT__;
      }
      if (injectStyles) {
        injectStyles.call(this, context);
      }
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier);
      }
    };
    options._ssrRegister = hook;
  } else if (injectStyles) {
    hook = shadowMode ? function() {
      injectStyles.call(this, (options.functional ? this.parent : this).$root.$options.shadowRoot);
    } : injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

var __vue2_script = defineComponent({
  emits: ["resize", "visible", "hidden", "update", "scroll-start", "scroll-end"],
  props: [].concat(props, ["items", "keyField", "direction", "listTag", "itemTag", "itemSize", "gridItems", "itemSecondarySize", "minItemSize", "sizeField", "typeField", "buffer", "pageMode", "prerender", "emitUpdate", "updateInterval", "skipHover", "listClass", "itemClass", "itemsLimit"]),
  directives: {
    ObserveVisibility
  },
  setup: function setup(props2, context) {
    return _setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
var render = function render2() {
  var _class, _style;
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    directives: [{
      name: "observe-visibility",
      rawName: "v-observe-visibility",
      value: _vm.handleVisibilityChange,
      expression: "handleVisibilityChange"
    }],
    staticClass: "tiny-recycle-scroller",
    class: (_class = {
      ready: _vm.state.ready,
      "page-mode": _vm.pageMode
    }, _class["direction-" + _vm.direction] = true, _class),
    on: {
      "&scroll": function scroll($event) {
        return _vm.handleScroll.apply(null, arguments);
      }
    }
  }, [_vm.slots.before ? _c("div", {
    ref: "before",
    staticClass: "tiny-recycle-scroller__slot"
  }, [_vm._t("before")], 2) : _vm._e(), _c(_vm.listTag, {
    ref: "wrapper",
    tag: "component",
    staticClass: "tiny-recycle-scroller__item-wrapper",
    class: _vm.listClass,
    style: (_style = {}, _style[_vm.direction === "vertical" ? "minHeight" : "minWidth"] = _vm.state.totalSize + "px", _style)
  }, [_vm._l(_vm.state.pool, function(view) {
    return _c(_vm.itemTag, _vm._g({
      key: view.nr.id,
      tag: "component",
      staticClass: "tiny-recycle-scroller__item-view",
      class: [_vm.itemClass, {
        hover: !_vm.skipHover && _vm.state.hoverKey === view.nr.key
      }],
      style: _vm.computeViewStyle(view)
    }, _vm.computeViewEvent(view)), [_vm._t("default", null, {
      "item": view.item,
      "index": view.nr.index,
      "active": view.nr.used
    })], 2);
  }), _vm._t("empty")], 2), _vm.slots.after ? _c("div", {
    ref: "after",
    staticClass: "tiny-recycle-scroller__slot"
  }, [_vm._t("after")], 2) : _vm._e()], 1);
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles, null, null, null);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var pc = /* @__PURE__ */ function() {
  return __component__.exports;
}();
export {
  pc as default
};
