declare const _default: {
    name: string;
    props: {
        items: {
            type: ArrayConstructor;
            required: boolean;
        };
        keyField: {
            type: StringConstructor;
            default: string;
        };
        direction: {
            type: StringConstructor;
            default: string;
            validator: (value: any) => boolean;
        };
        listTag: {
            type: StringConstructor;
            default: string;
        };
        itemTag: {
            type: StringConstructor;
            default: string;
        };
        itemSize: {
            type: NumberConstructor;
            default: null;
        };
        gridItems: {
            type: NumberConstructor;
            default: undefined;
        };
        itemSecondarySize: {
            type: NumberConstructor;
            default: undefined;
        };
        minItemSize: {
            type: (StringConstructor | NumberConstructor)[];
            default: null;
        };
        sizeField: {
            type: StringConstructor;
            default: string;
        };
        typeField: {
            type: StringConstructor;
            default: string;
        };
        buffer: {
            type: NumberConstructor;
            default: number;
        };
        pageMode: {
            type: BooleanConstructor;
            default: boolean;
        };
        prerender: {
            type: NumberConstructor;
            default: number;
        };
        emitUpdate: {
            type: BooleanConstructor;
            default: boolean;
        };
        updateInterval: {
            type: NumberConstructor;
            default: number;
        };
        skipHover: {
            type: BooleanConstructor;
            default: boolean;
        };
        listClass: {
            type: (ArrayConstructor | ObjectConstructor | StringConstructor)[];
            default: string;
        };
        itemClass: {
            type: (ArrayConstructor | ObjectConstructor | StringConstructor)[];
            default: string;
        };
        itemsLimit: {
            type: NumberConstructor;
            default: number;
        };
        tiny_mode: StringConstructor;
        tiny_mode_root: BooleanConstructor;
        tiny_template: (ObjectConstructor | FunctionConstructor)[];
        tiny_renderless: FunctionConstructor;
        tiny_theme: StringConstructor;
        tiny_chart_theme: ObjectConstructor;
    };
    setup(props: any, context: any): () => any;
};
export default _default;
